EOL	equ NULL
CRLF	equ <13, 10, EOL>

%LOG macro Msg$, ArgList:VARARG
Local S$
	ifdef OPT_ENABLE_DBG_LOG
		Args = 1
		For Arg, <ArgList>
			Args = Args + 1
			push Arg
		Endm
	.data
		S$ CHAR Msg$, CRLF
	.code
		push offset S$
		Call DbgPrint
		add esp,Args * 4
	endif
endm

%LGM macro Msg$, ArgList:VARARG
Local S$
	ifdef OPT_ENABLE_DBG_LOG
		Args = 1
		For Arg, <ArgList>
			Args = Args + 1
			push Arg
		Endm
	.data
		S$ CHAR Msg$
	.code
		push offset S$
		Call DbgPrint
		add esp,Args * 4
	endif
endm

Log@OBJECT_ATTRIBUTES proc uses ebx ObjAttr:POBJECT_ATTRIBUTES
Local Info[MAX_PATH]:WCHAR
	mov ebx,ObjAttr
	assume ebx:POBJECT_ATTRIBUTES
	%LOG "OBJECT_ATTRIBUTES {"
	.if [Ebx].hRootDirectory
		invoke ZwQueryObject, [Ebx].hRootDirectory, ObjectNameInformation, addr Info, MAX_PATH*2, NULL
		lea ecx,Info
		.if !Eax
			%DBG "   RootDirectory(0x%X): %wZ", Ecx, [Ebx].hRootDirectory
		.else
			%DBG "   RootDirectory(0x%X): (NtQueryObject failed with 0x%X)", Eax, [Ebx].hRootDirectory
		.endif
	.endif
	.if [Ebx].pObjectName
		%DBG "   ObjectName: %wZ", [Ebx].pObjectName
	.endif
	%LOG "   Attributes: 0x%X", [Ebx].uAttributes
	%LOG "   }"
	ret
Log@OBJECT_ATTRIBUTES endp

Log@CLIENT_ID proc uses ebx Cid:PCLIENT_ID
	mov ebx,Cid
	assume ebx:PCLIENT_ID
	.if Cid
		%LOG "CLIENT_ID {"
		%LOG "   UniqueProcess: 0x%X", [Ebx].UniqueProcess
		%LOG "   UniqueThread: 0x%X", [Ebx].UniqueThread
		%LOG "   }"
	.endif
	ret
Log@CLIENT_ID endp

Log@LDR_DATA_TABLE_ENTRY proc uses ebx Entry:PLDR_DATA_TABLE_ENTRY
	mov ebx,Entry
	assume ebx:PLDR_DATA_TABLE_ENTRY
	%LOG "LDR_DATA_TABLE_ENTRY }"
	%LOG "   DllBase: 0x%X", [Ebx].DllBase
	%LOG "   EntryPoint: 0x%X", [Ebx].EntryPoint
	%LOG "   SizeOfImage: 0x%X", [Ebx].SizeOfImage
	%LOG "   Flags: 0x%X", [Ebx].Flags
	%LOG "   LoadCount: 0x%X", [Ebx].LoadCount
	lea ebx,[ebx].FullDllName
	%LOG "   FullDllName: %wZ", Ebx
	%LOG "   }"
	ret
Log@LDR_DATA_TABLE_ENTRY endp

Log@NT_TIB proc uses ebx Tib:PNT_TIB
	mov ebx,Tib
	assume ebx:PNT_TIB
	%LOG "NT_TIB {"
	%LOG "   ExceptionList: 0x%X", [Ebx].ExceptionList
	%LOG "   StackBase: 0x%X", [Ebx].StackBase
	%LOG "   StackLimit: 0x%X", [Ebx].StackLimit
	%LOG "   Self: 0x%X", [Ebx].Self
	%LOG "   }"
	ret
Log@NT_TIB endp

Log@CONTEXT proc uses ebx Context:PCONTEXT
	mov ebx,Context
	assume ebx:PCONTEXT
	%LOG "CONTEXT {"
	%LOG "   Flags: 0x%X", [Ebx].ContextFlags
	test [ebx].ContextFlags,CONTEXT_DEBUG_REGISTERS
	.if !Zero?
		%LOG "   Dr0: 0x%X, Dr1: 0x%X, D2: 0x%X, Dr3: 0x%X, Dr6: 0x%X, Dr7: 0x%X", [Ebx].rDr7, [Ebx].rDr6, [Ebx].rDr3, [Ebx].rDr2, [Ebx].rDr1, [Ebx].rDr0
	.endif
	test [ebx].ContextFlags,CONTEXT_SEGMENTS
	.if !Zero?
		%LOG "   Gs: 0x%X, Fs: 0x%X, Es: 0x%X, Ds: 0x%X", [Ebx].rDs, [Ebx].rEs, [Ebx].rFs, [Ebx].rGs
	.endif
	test [ebx].ContextFlags,CONTEXT_INTEGER
	.if !Zero?
		%LOG "   Edi: 0x%X, Esi: 0x%X, Ebx: 0x%X, Edx: 0x%X, Ecx: 0x%X, Eax: 0x%X", [Ebx].rEax, [Ebx].rEcx, [Ebx].rEdx, [Ebx].rEbx, [Ebx].rEsi, [Ebx].rEdi
	.endif
	test [ebx].ContextFlags,CONTEXT_CONTROL
	.if !Zero?
		%LOG "   Ebp: 0x%X, Eip: 0x%X, Cs: 0x%X, EFlags: 0x%X, Esp: 0x%X, Ss: 0x%X", [Ebx].rSs, [Ebx].rEsp, [Ebx].rEFlags, [Ebx].rCs, [Ebx].rEip, [Ebx].rEbp
	.endif
	%LOG "   }"
	ret
Log@CONTEXT endp

Log@EXCEPTION_RECORD proc uses ebx esi Xcpt:PEXCEPTION_RECORD
	mov ebx,Xcpt
	assume ebx:PEXCEPTION_RECORD
	xor esi,esi
	%LOG "EXCEPTION_RECORD {"
	%LOG "   ExceptionCode: 0x%X", [Ebx].ExceptionCode
	%LOG "   ExceptionAddress: 0x%X", [Ebx].ExceptionAddress
	%LOG "   NumberParameters: 0x%X", [Ebx].NumberParameters
	.while [Ebx].NumberParameters != Esi
		%LOG "   ExceptionInformation{0x%X}: 0x%X", [Ebx].ExceptionInformation[Esi*4], Esi
		inc esi
	.endw
	%LOG "   }"
	ret
Log@EXCEPTION_RECORD endp

Log@SYSTEM_BASIC_INFORMATION proc uses ebx Info:PSYSTEM_BASIC_INFORMATION
	mov ebx,Info
	assume ebx:PSYSTEM_BASIC_INFORMATION
	%LOG "SYSTEM_BASIC_INFORMATION {"
	%LOG "   TimerResolution: 0x%X", [Ebx].TimerResolution
	%LOG "   PageSize: 0x%X", [Ebx].PageSize
	%LOG "   NumberOfPhysicalPages: 0x%X", [Ebx].NumberOfPhysicalPages
	%LOG "   LowestPhysicalPageNumber: 0x%X", [Ebx].LowestPhysicalPageNumber
	%LOG "   HighestPhysicalPageNumber: 0x%X", [Ebx].HighestPhysicalPageNumber
	%LOG "   AllocationGranularity: 0x%X", [Ebx].AllocationGranularity
	%LOG "   MinimumUserModeAddress: 0x%X", [Ebx].MinimumUserModeAddress
	%LOG "   MaximumUserModeAddress: 0x%X", [Ebx].MaximumUserModeAddress
	%LOG "   ActiveProcessorsAffinityMask: 0x%X", [Ebx].ActiveProcessorsAffinityMask
	movzx ebx,[ebx].NumberOfProcessors
	%LOG "   NumberOfProcessors: 0x%X", Ebx
	%LOG "   }"
	ret
Log@SYSTEM_BASIC_INFORMATION endp

Log@THREAD_BASIC_INFORMATION proc uses ebx Info:PTHREAD_BASIC_INFORMATION
	mov ebx,Info
	assume ebx:PTHREAD_BASIC_INFORMATION
	%LOG "THREAD_BASIC_INFORMATION {"
	invoke FltIdToSTID, [Ebx].ExitStatus
	.if Eax
		%LOG "   ExitStatus: %s(%s)", STID.Nam3[Eax], STID.Value[Eax]
	.else
		%LOG "   ExitStatus: 0x%X", [Ebx].ExitStatus
	.endif
	%LOG "   TebBaseAddress: 0x%X", [Ebx].TebBaseAddress
	%LOG "   CLIENT_ID {"
	%LOG "      UniqueProcess: 0x%X", [Ebx].ClientId.UniqueProcess
	%LOG "      UniqueThread: 0x%X", [Ebx].ClientId.UniqueThread
	%LOG "      }"
	%LOG "   AffinityMask: 0x%X", [Ebx].AffinityMask
	%LOG "   Priority: 0x%X", [Ebx].Priority
	%LOG "   BasePriority: 0x%X", [Ebx].BasePriority
	%LOG "   }"
	ret
Log@THREAD_BASIC_INFORMATION endp

Log@PROCESS_BASIC_INFORMATION proc uses ebx Info:PPROCESS_BASIC_INFORMATION
	mov ebx,Info
	assume ebx:PPROCESS_BASIC_INFORMATION
	%LOG "   ROCESS_BASIC_INFORMATION {"
	.if Eax
		%LOG "   ExitStatus: %s(%s)", STID.Nam3[Eax], STID.Value[Eax]
	.else
		%LOG "   ExitStatus: 0x%X", [Ebx].ExitStatus
	.endif
	%LOG "   PebBaseAddress: 0x%X", [Ebx].PebBaseAddress
	%LOG "   AffinityMask: 0x%X", [Ebx].AffinityMask
	%LOG "   BasePriority: 0x%X", [Ebx].BasePriority
	%LOG "   UniqueProcessId: 0x%X", [Ebx].UniqueProcessId
	%LOG "   InheritedFromUniqueProcessId: 0x%X", [Ebx].InheritedFromUniqueProcessId
	%LOG "   }"
	ret
Log@PROCESS_BASIC_INFORMATION endp

