EFLAGS_TF_BIT	equ 8

	assume fs:nothing
%GET_NT_BASE macro Reg32
	mov Reg32,fs:[TEB.Peb]
	mov Reg32,PEB.Ldr[Reg32]
	mov Reg32,PEB_LDR_DATA.InLoadOrderModuleList.Flink[Reg32]
	mov Reg32,LDR_DATA_TABLE_ENTRY.InLoadOrderModuleList.Flink[Reg32]
	mov Reg32,LDR_DATA_TABLE_ENTRY.DllBase[Reg32]	; ntdll.dll
endm

; +
;   ntdll.
;
LdrGetNtBase proc C
	%GET_NT_BASE Eax
	ret
LdrGetNtBase endp

; +
;  .
;
ShowDialog proc $Title:PSTR, $Text:PSTR, ResponseOption:ULONG, Style:ULONG	
Local Msg[3*4]:PVOID
Local TextU:UNICODE_STRING
Local TitleU:UNICODE_STRING
Local Response:ULONG	; HARDERROR_RESPONSE
	lea eax,TextU
	lea ecx,TitleU
	mov edx,Style
	mov Msg[0],eax
	mov Msg[4],ecx
	mov Msg[2*4],edx
	invoke RtlCreateUnicodeStringFromAsciiz, addr TitleU, $Title
	invoke RtlCreateUnicodeStringFromAsciiz, addr TextU, $Text
	invoke ZwRaiseHardError, STATUS_SERVICE_NOTIFICATION, 3, 3, addr Msg, ResponseOption, addr Response
	invoke RtlFreeUnicodeString, addr TitleU
	invoke RtlFreeUnicodeString, addr TextU
	mov eax,Response
	ret
ShowDialog endp

EOL	equ NULL
CRLF	equ <13, 10, EOL>

%DBG macro Msg$, ArgList:VARARG
Local S$
	ifdef OPT_ENABLE_DBG_LOG
		pushfd
		pushad
		Args = 1
		For Arg, <ArgList>
			Args = Args + 1
			push Arg
		Endm
	.data
		S$ CHAR Msg$, CRLF
	.code
		push offset S$
		Call DbgPrint
		add esp,Args * 4
		popad
		popfd
	endif
endm

; +
; 
LDE proc C
	xchg D[esp + 4],esi
	Call VirXasm32
	mov esi,D[esp + 4]
	retn 4
LDE endp

; +
;
AllocMemory proc S1ze:ULONG
Local Base:PVOID
	mov Base,NULL
	invoke ZwAllocateVirtualMemory, NtCurrentProcess, addr Base, 0, addr S1ze, MEM_COMMIT, PAGE_EXECUTE_READWRITE
	.if Eax
		xor eax,eax
	.else
		mov eax,Base
	.endif
	ret
AllocMemory endp

CPU_FAMILY	equ 111100000000B
CPU_MODEL		equ 000011110000B
CPU_STEPPING	equ 000000001111B

; +
;   SEP.
;
IsFastSystemCallEnable proc uses ebx esi
	xor esi,esi
	inc esi
	mov eax,esi
	cpuid
	bt edx,11	; SEP
	mov ecx,eax
	mov edx,eax
	.if Carry?
		and eax,CPU_FAMILY
		and ecx,CPU_MODEL
		and edx,CPU_STEPPING
		.if (Eax == (6 shl 8)) && (Cl < 3) && (Dl < 3)
			dec esi
		.endif
	.else
		dec esi
	.endif
	mov eax,esi
	ret
IsFastSystemCallEnable endp

_imp__ZwDelayExecution proto Alertable:BOOLEAN, Interval:PLARGE_INTEGER

; +
;   _SecurityCookieInitialized.
;
FindThreadLock proc uses ebx
	invoke RtlImageNtHeader, g_NtBase
	mov edx,g_NtBase
	mov ebx,D[_imp__ZwDelayExecution]
	movzx ecx,IMAGE_NT_HEADERS.FileHeader.SizeOfOptionalHeader[eax]
	add edx,IMAGE_SECTION_HEADER.VirtualAddress[eax + ecx + IMAGE_NT_HEADERS.OptionalHeader]
	mov ecx,IMAGE_SECTION_HEADER.VirtualSize[eax + ecx + IMAGE_NT_HEADERS.OptionalHeader]
	.repeat
		.if (D[Edx] == 0E8006A50H) && (D[Edx + 0FH] == 0C3C9EC74H) && (W[Edx + 8] == 3D80H) && (B[Edx + 0EH] == 0)
			mov eax,D[edx + 4]
			lea eax,[eax + (edx + 3) + 5]
			.if Eax == Ebx
				lea ecx,[edx + 8]
				mov eax,D[edx + 0AH]	; @SecurityCookieInitialized
				mov g_LockThreadIp,ecx	;    .
				mov g_LockThread,eax
				jmp Exit
			.endif
		.endif
		inc edx
		dec ecx
	.until Zero?
	xor eax,eax
Exit:
	ret
FindThreadLock endp

$Log		CHAR "\??\D:\Log.txt", 0

.data
g_File			HANDLE ?

.code
; +
;
CreateLog proc
Local NameU:UNICODE_STRING
Local ObjAttr:OBJECT_ATTRIBUTES
Local IoStatus:IO_STATUS_BLOCK
	invoke RtlCreateUnicodeStringFromAsciiz, addr NameU, addr $Log
	lea eax,NameU
	mov ObjAttr.uLength,sizeof(OBJECT_ATTRIBUTES)
	mov ObjAttr.uAttributes,OBJ_CASE_INSENSITIVE
	mov ObjAttr.hRootDirectory,NULL
	mov ObjAttr.pObjectName,eax
	mov ObjAttr.pSecurityDescriptor,NULL
	mov ObjAttr.pSecurityQualityOfService,NULL
	invoke ZwCreateFile, addr g_File, 40100080H, addr ObjAttr, addr IoStatus, NULL, 80H, 1, 5, 60H, NULL, 0
	push eax
	invoke RtlFreeUnicodeString, addr NameU
	pop eax
	ret
CreateLog endp

; +
;
WriteLog proc Msg:PSTR, MsgLen:ULONG
Local Io:IO_STATUS_BLOCK
		invoke ZwWriteFile, g_File, NULL, NULL, NULL, addr Io, Msg, MsgLen, 0, NULL
		ret
WriteLog endp