PUBLIC g_ShellPid
.data
g_ShellPid	HANDLE ?

.code
; +
;
Convert100nsToMilliseconds proc nS:PLARGE_INTEGER
	mov eax,nS
	mov edx,D[eax + 4]
	mov eax,D[eax]
	neg eax
	adc edx,0
	neg edx
	invoke RtlExtendedLargeIntegerDivide, Eax, Edx, 10000, 0
	ret
Convert100nsToMilliseconds endp

%NTCALL macro Id, Args
	mov eax,Id
	mov edx,Args
	Int 2Eh
endm

; [rEsp]:
;	@Fret	; *      Fret.
;	...
;	NTSTATE{}
;	...
;
; rEbx: Arg's
; rEsi: PNTID
; rEdi: NTSTATE
;

; +
;   .
;
pInitSecurityCookie proc C
	mov eax,STACK_FRAME.Next[ebp]
	mov ebx,D[eax + sizeof(STACK_FRAME)]
	assume ebx:PCONTEXT
	%DBG "THREAD(TID: 0x%X, rEip: 0x%X, rEax: 0x%X, rEbx: 0x%X)", [Ebx].rEbx, [Ebx].rEax, [Ebx].rEip, fs:[TEB.Cid.UniqueThread]
	leave
	retn
pInitSecurityCookie endp

.data
g_LockThread		PPVOID ?
g_LockThreadIp		PVOID ?

g_WaitThreadLock	BOOLEAN ?	;   .

.code
_NtDelayExecution struct
Alertable		BOOLEAN ?
DelayInterval	PLARGE_INTEGER ?
_NtDelayExecution ends

pNtDelayExecution proc C
	assume ebx:ptr _NtDelayExecution
	ifdef OPT_THREAD_LIST
		invoke TlsAdd
	endif
	mov eax,D[ebx - 4]	; Ip
	.if g_LockThreadIp == Eax	;       .
		.repeat
			cmp g_WaitThreadLock,FALSE	;   g_LockThread,   
			;  ( (30ms)),   .
		.until Zero?
		mov D[ebx - 4],offset pInitSecurityCookie
		jmp FleaveOk
	.endif
	ret
pNtDelayExecution endp

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ USER API ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%STATUS macro
	%NTCALL NTID.Id[Esi], Ebx
	mov esi,eax
	invoke FltIdToSTID, Eax
	.if Eax
		%LOG "   ): %s(%s)", STID.Nam3[Eax], STID.Value[Eax]
	.else
		%LOG "   ): 0x%X", Esi
	.endif
endm

_NtClose struct
ObjectHandle			HANDLE ?
_NtClose ends

; +
; - Validation.
;
pNtClose proc
Local Info[MAX_PATH]:WCHAR
	assume ebx:ptr _NtClose
	%LOG "NtClose("
	invoke ZwQueryObject, [Ebx].ObjectHandle, ObjectNameInformation, addr Info, MAX_PATH*2, NULL
	lea ecx,Info
	.if !Eax
		%LOG "   ObjectHandle: 0x%X(%wZ)", Ecx, [Ebx].ObjectHandle
	.else
		%LOG "   ObjectHandle: 0x%X", [Ebx].ObjectHandle
	.endif
	%STATUS
	%LOG " "
	leave
	mov eax,esi
	jmp Fleave
pNtClose endp

_NtOpenProcess struct
ProcessHandle			PHANDLE ?
DesiredAccess			ACCESS_MASK ?
ObjectAttributes		POBJECT_ATTRIBUTES ?
ClientId				PCLIENT_ID ?
_NtOpenProcess ends

; +
;
pNtOpenProcess proc C
	assume ebx:ptr _NtOpenProcess
	%LOG "NtOpenProcess("
	%LOG "   ProcessHandle:PHANDLE(0x%X)", [Ebx].ProcessHandle
	%LOG "   ObjectAttributes:POBJECT_ATTRIBUTES(0x%X)", [Ebx].ObjectAttributes
	invoke Log@OBJECT_ATTRIBUTES, [Ebx].ObjectAttributes
	%LOG "   DesiredAccess: 0x%X", [Ebx].DesiredAccess
	%LOG "   ClientId:PCLIENT_ID(0x%X)", [Ebx].ClientId
	mov eax,[ebx].ClientId
	.if Eax
		invoke Log@CLIENT_ID, Eax
	.endif
	%STATUS
	.if !Esi
		mov ebx,[ebx].ProcessHandle
		%LOG " -> ProcessHandle: 0x%X", D[Ebx]
	.endif
	%LOG " "
	mov eax,esi
	jmp Fleave
pNtOpenProcess endp

_NtTerminateProcess struct
ProcessHandle			HANDLE ?
ExitStatus			NTSTATUS ?
_NtTerminateProcess ends

; +
; - Access.
;
pNtTerminateProcess proc
Local Info:PROCESS_BASIC_INFORMATION
	assume ebx:ptr _NtTerminateProcess
	%LOG "NtTerminateProcess("
	invoke ZwQueryInformationProcess, [Ebx].ProcessHandle, ProcessBasicInformation, addr Info, sizeof(PROCESS_BASIC_INFORMATION), NULL
	.if !Eax
		%LOG "   ProcessHandle: 0x%X(PID: 0x%X)", Info.UniqueProcessId, [Ebx].ProcessHandle
	.else
		%LOG "   ProcessHandle: 0x%X", [Ebx].ProcessHandle
	.endif
	%LOG "   ExitStatus: 0x%X", [Ebx].ExitStatus
	%STATUS
	%LOG " "
	leave
	mov eax,esi
	jmp Fleave
pNtTerminateProcess endp

_NtCreateFile struct
FileHandle			PHANDLE ?
DesiredAccess			ACCESS_MASK ?
ObjectAttributes		POBJECT_ATTRIBUTES ?
IoStatusBlock			PIO_STATUS_BLOCK ?
AllocationSize			PLARGE_INTEGER ?
FileAttributes			ULONG ?
ShareAccess			ULONG ?
CreateDisposition		ULONG ?
CreateOptions			ULONG ?
EaBuffer				PVOID ?
EaLength				ULONG ?
_NtCreateFile ends

; +
;
pNtCreateFile proc C
	assume ebx:ptr _NtCreateFile
	%LOG "NtCreateFile("
	%LOG "   FileHandle:PHANDLE(0x%X)", [Ebx].FileHandle
	%LOG "   DesiredAccess: 0x%X", [Ebx].DesiredAccess
	%LOG "   ObjectAttributes:POBJECT_ATTRIBUTES(0x%X)", [Ebx].ObjectAttributes
	invoke Log@OBJECT_ATTRIBUTES, [Ebx].ObjectAttributes
	%LOG "   FileAttributes: 0x%X",  [Ebx].FileAttributes
	%LOG "   ShareAccess: 0x%X",  [Ebx].ShareAccess
	%LOG "   CreateDisposition: 0x%X",  [Ebx].CreateDisposition
	%LOG "   CreateOptions: 0x%X",  [Ebx].CreateOptions
	%STATUS
	.if !Esi
		mov ebx,[ebx].FileHandle
		%LOG " -> FileHandle: 0x%X", D[Ebx]
	.endif
	%LOG " "
	mov eax,esi
	jmp Fleave
pNtCreateFile endp

_NtContinue struct
Context		PCONTEXT ?
TestAlert		BOOLEAN ?
_NtContinue ends

; +
;
pNtContinue proc C
	assume ebx:ptr _NtContinue
	%LOG "NtContinue("
	invoke Log@CONTEXT, [Ebx].Context
	%LOG "   TestAlert: 0x%X", [Ebx].TestAlert
	%LOG "   )"
	%LOG " "
	retn
pNtContinue endp

_NtQueryInformationThread struct
ThreadHandle			HANDLE ?
ThreadInformationClass	ULONG ?
ThreadInformation		PVOID ?
ThreadInformationLength	ULONG ?
ReturnLength			PULONG ?
_NtQueryInformationThread ends

MaxThreadInfoClass	equ 22

; +
;
pNtQueryInformationThread proc
Local Info:THREAD_BASIC_INFORMATION
	assume ebx:ptr _NtQueryInformationThread
	%LOG "NtQueryInformationThread("
	%LOG "   ThreadHandle: 0x%X", [Ebx].ThreadHandle
	invoke ZwQueryInformationThread, [Ebx].ThreadHandle, ThreadBasicInformation, addr Info, sizeof(THREAD_BASIC_INFORMATION), NULL
	mov edi,[ebx].ThreadInformationClass
	.if !Eax
		invoke Log@CLIENT_ID, addr Info.ClientId
	.endif
	%LOG "   ThreadInformationClass: 0x%X", Edi
	%LOG "   ThreadInformation: 0x%X", [Ebx].ThreadInformation
	%LOG "   ThreadInformationLength: 0x%X", [Ebx].ThreadInformationLength
	%LOG "   ReturnLength:PULONG(0x%X)", [Ebx].ReturnLength
	%STATUS
	.if !Esi
		mov eax,[ebx].ReturnLength
		.if Eax
			%LOG " -> ReturnLength: 0x%X", D[Eax]
		.endif
		.if Edi < MaxThreadInfoClass
			mov ebx,[ebx].ThreadInformation
			Call D[ThreadInfoClass + Edi*4]
		.else
			; Dump it.
			; ...
		.endif
	.endif
	%LOG " "
	mov eax,esi
	leave
	jmp Fleave
	
iThreadBasicInformation:
	%LOG " -> (ThreadBasicInformation):"
	invoke Log@THREAD_BASIC_INFORMATION, Ebx
	retn
iThreadTimes:
	%LOG " -> (ThreadTimes):"
	%LOG "KERNEL_USER_TIMES {"
	assume ebx:PKERNEL_USER_TIMES
	lea eax,[ebx].CreateTime
	invoke Convert100nsToMilliseconds, Eax
	%LOG "   CreateTime: 0x%X ms", Eax
	lea eax,[ebx].ExitTime
	invoke Convert100nsToMilliseconds, Eax
	%LOG "   ExitTime: 0x%X ms", Eax
	lea eax,[ebx].KernelTime
	invoke Convert100nsToMilliseconds, Eax
	%LOG "   KernelTime: 0x%X ms", Eax
	lea eax,[ebx].UserTime
	invoke Convert100nsToMilliseconds, Eax
	%LOG "   UserTime: 0x%X ms", Eax
	%LOG "   }"
	retn
iThreadPriority:
	%LOG " -> (ThreadPriority):"
	%LOG "KPRIORITY {"
	%LOG "   Priority: 0x%X", D[Ebx]
	%LOG "   }"
	retn
iThreadBasePriority:
	%LOG " -> (ThreadBasePriority):"
	%LOG "{BasePriority: 0x%X}", D[Ebx]
	retn
iThreadAffinityMask:
	%LOG " -> (ThreadAffinityMask):"
	%LOG "KAFFINITY {"
	%LOG "   AffinityMask: 0x%X", D[Ebx]
	%LOG "   }"
	retn
iThreadImpersonationToken:
	%LOG " -> (ThreadImpersonationToken):"
	%LOG "{ImpersonationToken: 0x%X}", D[Ebx]
	retn
iThreadDescriptorTableEntry:

DESCRIPTOR_TABLE_ENTRY struct
Selector		ULONG ?
Descriptor	DWORD 2 DUP (?)	; LDT_ENTRY
DESCRIPTOR_TABLE_ENTRY ends
	
	assume ebx:ptr DESCRIPTOR_TABLE_ENTRY
	%LOG " -> (ThreadDescriptorTableEntry):"
	%LOG "DESCRIPTOR_TABLE_ENTRY {"
	%LOG "   Selector: 0x%X", [Ebx].Selector
	%LOG "   Descriptor[0]: 0x%X", [Ebx].Descriptor[0]
	%LOG "   Descriptor[4]: 0x%X", [Ebx].Descriptor[4]
	%LOG "   }"
	retn
iThreadEnableAlignmentFaultFixup:
	%LOG " -> (ThreadEnableAlignmentFaultFixup):"
	%LOG "{EnableAlignmentFaultFixup: 0x%X}", D[Ebx]
	retn
iThreadEventPair_Reusable:
	%LOG " -> (ThreadEventPair):"
	; ... dump.
	retn
iThreadQuerySetWin32StartAddress:
	%LOG " -> (ThreadQuerySetWin32StartAddress):"
	%LOG "{Win32StartAddress: 0x%X}", D[Ebx]
	retn
iThreadZeroTlsCell:
	%LOG " -> (ThreadZeroTlsCell):"
	%LOG "{ZeroTlsCell: 0x%X}", D[Ebx]
	retn
iThreadPerformanceCount:
	%LOG " -> (ThreadPerformanceCount):"
	invoke Convert100nsToMilliseconds, Ebx
	%LOG "{PerformanceCount: 0x%X ms}", Eax
	retn
iThreadAmILastThread:
	%LOG " -> (ThreadAmILastThread):"
	%LOG "{AmILastThread: 0x%X}", D[Ebx]
	retn
iThreadIdealProcessor:
	%LOG " -> (ThreadIdealProcessor):"
	%LOG "{IdealProcessor: 0x%X}", D[Ebx]
	retn
iThreadPriorityBoost:
	%LOG " -> (ThreadPriorityBoost):"
	%LOG "{PriorityBoost: 0x%X}", D[Ebx]
	retn
iThreadSetTlsArrayAddress:
	%LOG " -> (ThreadSetTlsArrayAddress):"
	%LOG "{TlsArrayAddress: 0x%X}", D[Ebx]
	retn
iThreadIsIoPending:
	%LOG " -> (ThreadIsIoPending):"
	%LOG "{IsIoPending: 0x%X}", D[Ebx]
	retn
iThreadHideFromDebugger:
	%LOG " -> (ThreadHideFromDebugger):"
	%LOG "{HideFromDebugger: 0x%X}", D[Ebx]
	retn
iThreadBreakOnTermination:
	%LOG " -> (ThreadBreakOnTermination):"
	%LOG "{BreakOnTermination: 0x%X}", D[Ebx]
	retn
iThreadSwitchLegacyState:
	%LOG " -> (ThreadSwitchLegacyState)"
	retn
iThreadIsTerminated:
	%LOG " -> (ThreadIsTerminated):"
	%LOG "{ThreadTerminated: 0x%X}", D[Ebx]
	retn
ThreadInfoClass:
	PVOID iThreadBasicInformation
	PVOID iThreadBasicInformation
	PVOID iThreadTimes
	PVOID iThreadPriority
	PVOID iThreadBasePriority
	PVOID iThreadAffinityMask
	PVOID iThreadImpersonationToken
	PVOID iThreadDescriptorTableEntry
	PVOID iThreadEnableAlignmentFaultFixup
	PVOID iThreadEventPair_Reusable
	PVOID iThreadQuerySetWin32StartAddress
	PVOID iThreadZeroTlsCell
	PVOID iThreadPerformanceCount
	PVOID iThreadAmILastThread
	PVOID iThreadIdealProcessor
	PVOID iThreadPriorityBoost
	PVOID iThreadSetTlsArrayAddress
	PVOID iThreadIsIoPending
	PVOID iThreadHideFromDebugger
	PVOID iThreadBreakOnTermination
	PVOID iThreadSwitchLegacyState
	PVOID iThreadIsTerminated
	CHAR EOL
pNtQueryInformationThread endp

_NtImpersonateAnonymousToken struct
ThreadHandle	HANDLE ?
_NtImpersonateAnonymousToken ends

pNtImpersonateAnonymousToken proc C
	assume ebx:ptr _NtImpersonateAnonymousToken
	%LOG "NtImpersonateAnonymousToken("
	%LOG "   ThreadHandle: 0x%X", [Ebx].ThreadHandle
	%STATUS
	%LOG " "
	mov eax,esi
	jmp Fleave
pNtImpersonateAnonymousToken endp

_NtAlertResumeThread struct
ThreadHandle			HANDLE ?
PreviousSuspendCount	PULONG ?
_NtAlertResumeThread ends 

pNtAlertResumeThread proc C
	assume ebx:ptr _NtAlertResumeThread
	%LOG "NtAlertResumeThread("
	%LOG "   ThreadHandle: 0x%X", [Ebx].ThreadHandle
	%LOG "   PreviousSuspendCount:PULONG(0x%X)", [Ebx].PreviousSuspendCount
	%STATUS
	.if Esi
		.if [Ebx].PreviousSuspendCount
			%LOG " -> PreviousSuspendCount: 0x%X", D[Ebx]
		.endif
	.endif
	%LOG " "
	mov eax,esi
	jmp Fleave
pNtAlertResumeThread endp

_NtRegisterThreadTerminatePort struct
PortHandle	HANDLE ?
_NtRegisterThreadTerminatePort ends

pNtRegisterThreadTerminatePort proc
Local Info[MAX_PATH]:WCHAR
	assume ebx:ptr _NtRegisterThreadTerminatePort
	%LOG "NtRegisterThreadTerminatePort("
	invoke ZwQueryObject, [Ebx].PortHandle, ObjectNameInformation, addr Info, MAX_PATH*2, NULL
	lea ecx,Info
	.if !Eax
		%LOG "   PortHandle: 0x%X(%wZ)", Ecx, [Ebx].PortHandle
	.else
		%LOG "   PortHandle: 0x%X", [Ebx].PortHandle
	.endif
	%STATUS
	%LOG " "
	mov eax,esi
	leave
	jmp Fleave
pNtRegisterThreadTerminatePort endp

_NtImpersonateThread struct
ThreadHandle		HANDLE ?
TargetThreadHandle	HANDLE ?
SecurityQos		PSECURITY_QUALITY_OF_SERVICE ?
_NtImpersonateThread ends

pNtImpersonateThread proc C
	assume ebx:ptr _NtImpersonateThread
	%LOG "NtRegisterThreadTerminatePort("
	%LOG "   ThreadHandle: 0x%X", [Ebx].ThreadHandle
	%LOG "   TargetThreadHandle: 0x%X", [Ebx].TargetThreadHandle
	%LOG "   SecurityQos:PSECURITY_QUALITY_OF_SERVICE(0x%X)", [Ebx].SecurityQos
	%STATUS
	%LOG " "
	mov eax,esi
	jmp Fleave
pNtImpersonateThread endp

_NtAlertThread struct
ThreadHandle		HANDLE ?
_NtAlertThread ends

pNtAlertThread proc C
	assume ebx:ptr _NtAlertThread
	%LOG "NtAlertThread("
	%LOG "   ThreadHandle: 0x%X", [Ebx].ThreadHandle
	%STATUS
	%LOG " "
	mov eax,esi
	jmp Fleave
pNtAlertThread endp

pNtTestAlert proc C
	%LOG "NtTestAlert("
	%STATUS
	%LOG " "
	mov eax,esi
	jmp Fleave
pNtTestAlert endp

_NtQueueApcThread struct
ThreadHandle	HANDLE ?
ApcRoutine	PVOID ?
ApcContext	PVOID ?
Argument1		PVOID ?
Argument2		PVOID ?
_NtQueueApcThread ends

pNtQueueApcThread proc C
	assume ebx:ptr _NtQueueApcThread
	%LOG "NtQueueApcThread("
	%LOG "   ThreadHandle: 0x%X", [Ebx].ThreadHandle
	%LOG "   ApcRoutine:PKNORMAL_ROUTINE(0x%X)", [Ebx].ApcRoutine
	%LOG "   ApcContext: 0x%X", [Ebx].ApcContext
	%LOG "   Argument1: 0x%X", [Ebx].Argument1
	%LOG "   Argument2: 0x%X", [Ebx].Argument2
	%STATUS
	%LOG " "
	mov eax,esi
	jmp Fleave
pNtQueueApcThread endp

_NtGetContextThread struct
ThreadHandle	HANDLE ?
Context		PCONTEXT ?
_NtGetContextThread ends

pNtGetContextThread proc C
	assume ebx:ptr _NtGetContextThread
	%LOG "NtGetContextThread("
	%LOG "   ThreadHandle: 0x%X", [Ebx].ThreadHandle
	%LOG "   Context:PCONTEXT(0x%X)", [Ebx].Context
	%STATUS
	.if !Esi
		invoke Log@CONTEXT, [Ebx].Context
	.endif
	%LOG " "
	mov eax,esi
	jmp Fleave
pNtGetContextThread endp

_NtOpenThread struct
ThreadHandle			PHANDLE ?
DesiredAccess			ACCESS_MASK ?
ObjectAttributes		POBJECT_ATTRIBUTES ?
ClientId				PCLIENT_ID ?
_NtOpenThread ends

pNtOpenThread proc C
	assume ebx:ptr _NtOpenThread
	%LOG "NtOpenThread("
	%LOG "   ThreadHandle:PHANDLE(0x%X)", [Ebx].ThreadHandle
	%LOG "   ObjectAttributes:POBJECT_ATTRIBUTES(0x%X)", [Ebx].ObjectAttributes
	invoke Log@OBJECT_ATTRIBUTES, [Ebx].ObjectAttributes
	%LOG "   DesiredAccess: 0x%X", [Ebx].DesiredAccess
	%LOG "   ClientId:PCLIENT_ID(0x%X)", [Ebx].ClientId
	mov eax,[ebx].ClientId
	.if Eax
		invoke Log@CLIENT_ID, Eax
	.endif
	%STATUS
	.if !Esi
		mov ebx,[ebx].ThreadHandle
		%LOG " -> ThreadHandle: 0x%X", D[Ebx]
	.endif
	%LOG " "
	mov eax,esi
	jmp Fleave
pNtOpenThread endp

_NtTerminateThread struct
ThreadHandle			HANDLE ?
ExitStatus			NTSTATUS ?
_NtTerminateThread ends

pNtTerminateThread proc
Local Info:THREAD_BASIC_INFORMATION
	assume ebx:ptr _NtTerminateThread
	%LOG "NtTerminateProcess("
	invoke ZwQueryInformationThread, [Ebx].ThreadHandle, ThreadBasicInformation, addr Info, sizeof(THREAD_BASIC_INFORMATION), NULL
	.if !Eax
		invoke Log@CLIENT_ID, addr Info.ClientId
	.else
		%LOG "   ThreadHandle: 0x%X", [Ebx].ThreadHandle
	.endif
	%LOG "   ExitStatus: 0x%X", [Ebx].ExitStatus
	%STATUS
	%LOG " "
	leave
	mov eax,esi
	jmp Fleave
pNtTerminateThread endp








