.code
	include VirXasm32b.asm
	
MAX_INSTRUCTION_SIZE	equ 15

; +
; Eax -  .
;
LPFX proc uses ebx esi edi Ip:PVOID
Local PfxTable[12]:BYTE
	mov ebx,MAX_INSTRUCTION_SIZE + 1
	mov D[PfxTable],02EF3F2F0H
	mov D[PfxTable + 4],06426363EH
	mov D[PfxTable + 8],000676665H
	mov esi,Ip
	cld
	lea edx,PfxTable
@@:
	dec ebx
	jz @f
	lodsb
	mov edi,edx
	mov ecx,11
	repne scasb
	je @b
@@:
	dec esi
	sub esi,Ip
	mov eax,esi
Exit:
	ret
LPFX endp

OP_ESC2B	equ 0FH

JCC_SHORT_OPCODE_BASE	equ 70H
JCC_NEAR_OPCODE_BASE	equ 80H

JCC_LOOPNE	equ 0E0H	; Ecx & !ZF
JCC_LOOPE		equ 0E1H	; Ecx & ZF
JCC_LOOP		equ 0E2H	; Ecx
JCC_ECXZ		equ 0E3H	; !Ecx

JCX_OPCODE_BASE	equ 0E0H

OP_JMP_SHORT	equ 0EBH
OP_JMP_NEAR	equ 0E9H

FLOW_ENTRY struct
Ip		PVOID ?
S1ze		ULONG ?
FLOW_ENTRY ends
PFLOW_ENTRY typedef ptr FLOW_ENTRY

; +
; o !NL.
;
Snapshot proc uses ebx esi edi Ip:PVOID, G:PVOID, pLDE:PVOID, Clbk:PVOID, Carg:PVOID
Local Ip0:PVOID
Local G0:PVOID
Local pSp:PVOID
	mov pSp,esp
	push NULL
	mov eax,G
; Ebx: LEN
; Esi: Ip
; Edi: LDE()
	mov esi,Ip
	mov G0,eax
Flow:
	xor ebx,ebx
	mov Ip0,esi
	jmp Step
Next:
	add ebx,edi
	add esi,edi
Step:
	mov ecx,G0
	mov edx,G
	.repeat
		mov eax,FLOW_ENTRY.Ip[ecx]
		.if Eax <= Esi
			add eax,FLOW_ENTRY.S1ze[ecx]
			cmp eax,esi
			ja Load	; Ip ~ G{}
		.endif
		add ecx,sizeof(FLOW_ENTRY)
	.until Ecx >= Edx
Scan:
	push esi
	Call pLDE
	cmp Clbk,NULL
	mov edi,eax
	.if !Zero?
		push FALSE
		push Carg
		push eax
		push esi
		Call Clbk	; (Ip, LDE(Ip), Arg)
		test eax,eax
		.if !Zero?
Break:
			mov esp,pSp
			jmp Exit
		.endif
	.endif
	
	invoke LPFX, Esi
	
	cmp al,MAX_INSTRUCTION_SIZE
	jnb Load
	
	movzx ecx,B[esi + eax]	; Opcode
	cmp cl,OP_ESC2B
	je ESC2B
	
	cmp cl,JCC_SHORT_OPCODE_BASE
	jb Next
	cmp cl,JCC_SHORT_OPCODE_BASE + 15
	ja IsJcx
Jcc:
	movzx eax,B[esi + eax + 1]	; Disp.
	btr eax,7
	.if Carry?
		sub eax,80H
	.endif
	lea eax,[eax + esi + 2]
JccFlow:
	cmp Clbk,NULL
	push eax	; Flow
	je Next

	push TRUE
	push Carg
	push eax
	push esi
	Call Clbk
	test eax,eax
	jnz Break
	jmp Next
ESC2B:
	movzx ecx,B[esi + eax + 1]
	cmp cl,JCC_NEAR_OPCODE_BASE
	jb Next
	cmp cl,JCC_NEAR_OPCODE_BASE + 15
	ja Next
	mov eax,D[esi + eax + 2]
	lea eax,[eax + esi + 6]
	jmp JccFlow
IsJcx:
	cmp cl,JCX_OPCODE_BASE
	jb IsJmp
	cmp cl,JCC_ECXZ
	jbe Jcc
IsJmp:
	cmp cl,OP_JMP_SHORT
	jne @f
	movzx eax,B[esi + eax + 1]
	btr eax,7
	.if Carry?
		sub eax,80H
	.endif
	lea eax,[eax + esi + 2]
Tjmp:
	cmp Clbk,NULL
	push eax	; Flow
	je Cont
	
	push TRUE
	push Carg
	push eax
	push esi
	Call Clbk
	test eax,eax
	jnz Break
	jmp Cont
@@:
	cmp cl,OP_JMP_NEAR
	jne @f
	mov eax,D[esi + eax + 1]
	lea eax,[eax + esi + 5]
	jmp Tjmp
@@:
	cmp cl,0FFH
	jne IsRet
	cmp B[esi + eax + 1],25H	; Grp. 5
	ifndef OPT_ENABLE_INDIRECT
		je Cont	; JMP m32 - end flow.
	else
		jne IsRet
		; o   ,  (Ds).
		mov eax,D[esi + eax + 2]
		mov eax,D[eax]	; Offset
		jmp Tjmp
	endif
IsRet:
	cmp cl,0C3H
	je Cont
	cmp cl,0C2H
	jne Next
Cont:
	add ebx,edi
Load:
	assume ecx:PFLOW_ENTRY
	mov ecx,G
	mov eax,Ip0
	mov [ecx].S1ze,ebx
	mov [ecx].Ip,eax
	add G,sizeof(FLOW_ENTRY)
xPop:
	pop esi
	test esi,esi
	jz Exit
	mov ecx,G0
	mov edx,G
	.repeat
		mov eax,FLOW_ENTRY.Ip[ecx]
		.if Eax <= Esi
			add eax,FLOW_ENTRY.S1ze[ecx]
			cmp eax,esi
			ja xPop	; Ip ~ G{}
		.endif
		add ecx,sizeof(FLOW_ENTRY)
	.until Ecx >= Edx
	xor ebx,ebx
	mov Ip0,esi
	jmp Scan
Exit:
	mov eax,G
	ret
Snapshot endp