PUBLIC FltIdToSTID
PUBLIC FltHashToSTID
PUBLIC FltNameToSTID

STID struct
Status	NTSTATUS ?	; .
Value	PSTR ?		; .
Nam3		PSTR ?		; .
Hash		ULONG ?		; .
Message	PSTR ?		; .
STID ends
PSTID typedef ptr STID

SB_LINES	equ 5397	;    .

.data
g_Sbase	PVOID ?
g_Ssize	ULONG ?
g_Slist	PSTID ?
g_Sents	ULONG ?

.code
; +
;     .
;
FltIdToSTID proc Status:NTSTATUS
	mov eax,g_Sents
	mov ecx,Status
	mov edx,g_Slist
	.repeat
		assume edx:PSTID
		cmp [edx].Status,ecx
		je Load
		add edx,sizeof(STID)
		dec eax
	.until Zero?
Exit:
	ret
Load:
	mov eax,edx
	jmp Exit
FltIdToSTID endp

; +
;      .
;
FltHashToSTID proc Hash:ULONG
	mov eax,g_Sents
	mov ecx,Hash
	mov edx,g_Slist
	.repeat
		assume edx:PSTID
		cmp [edx].Hash,ecx
		je Load
		add edx,sizeof(STID)
		dec eax
	.until Zero?
Exit:
	ret
Load:
	mov eax,edx
	jmp Exit
FltHashToSTID endp

; +
;     .
;
FltNameToSTID proc uses edi Nam3:PSTR
	cld
	xor eax,eax
	mov edi,Nam3
	mov ecx,100H
	repne scasb
	not ecx
	add ecx,100H
	invoke LdrCalculateHash, 0, Nam3, Ecx
	invoke FltHashToSTID, Eax
	ret
FltNameToSTID endp

SbaseW	WCHAR "N", "T", "S", "T", "A", "T", "U", "S", 0

	includelib \masm32\lib\masm32.lib
	
	htodw proto :PSTR

; +
;   .
;	
SbaseInitialize proc uses ebx esi edi
Local Res[3]:PVOID
Local Sentry:PIMAGE_RESOURCE_DATA_ENTRY
Local S1ze:ULONG
Local Buffer[12]:CHAR
	mov Res[0],RT_RCDATA
	mov Res[4],offset SbaseW
	mov Res[2*4],0
	invoke LdrFindResource_U, g_SelfBase, addr Res, 3, addr Sentry
	.if !Eax
		invoke LdrAccessResource, g_SelfBase, Sentry, addr g_Sbase, addr g_Ssize
		mov ecx,g_Ssize
		.if !Eax
			add ecx,(SB_LINES*sizeof(STID)/3) - SB_LINES
			mov esi,g_Sbase
			mov S1ze,ecx
			invoke ZwAllocateVirtualMemory, NtCurrentProcess, addr g_Slist, 0, addr S1ze, MEM_COMMIT, PAGE_READWRITE
			cld
			mov ebx,g_Slist
			lea edi,[ebx + SB_LINES*sizeof(STID)/3]
			mov S1ze,SB_LINES
			.if !Eax
				.repeat
					assume ebx:PSTID
					mov [ebx].Value,edi
					lea edx,[edi + 2]
					xor eax,eax
					movsd
					movsd
					movsw
					stosb	; EOL
					invoke htodw, Edx	; ~ 0x
					mov [ebx].Status,eax
					dec S1ze
					lodsw	; ~CRLF
					mov [ebx].Nam3,edi
					mov edx,esi
					;   .
				@@:
					lodsb
					cmp al,13	; CR
					je @f
					stosb
					jmp @b
				@@:
					sub edx,esi
					xor eax,eax
					not edx
					dec S1ze
					stosb	; EOL
					inc edx
					lodsb
					mov [ebx].Message,edi
					invoke LdrCalculateHash, 0, [Ebx].Nam3, Edx
					mov [ebx].Hash,eax
					ifdef OPT_HASH_COLLISION
						.if g_Sents
							invoke FltHashToSTID, Eax
							.if Eax
								%DBG "WARNING: HASH COLLISION(%s, %s)", [Ebx].Nam3, STID.Nam3[Eax]
							.endif
						.endif
					endif
					;  .
					inc g_Sents
				@@:	
					lodsb
					cmp al,13	; CR
					je @f
				Line:
					stosb
					cmp al,EOL
					jne @b
					dec S1ze
					jmp Exit
				@@:
					dec S1ze
					.if !Zero?
						cmp W[esi + 1],"x0"
						jne Line
					.endif
				Exit:	
					xor eax,eax
					lea ebx,[ebx + sizeof(STID)]
					cmp S1ze,eax
					stosb	; EOL
					lodsb
				.until Zero? || Sign?
				stosb
			.endif
		.endif
	.endif
	ret
SbaseInitialize endp

; +
;   .
;
DbgListSTID proc uses ebx esi
	mov ebx,g_Sents
	mov esi,g_Slist
	%DBG "/-- NTSTATUS LIST ---"
	.repeat
		assume esi:PSTID
		%DBG "%s, %s", [Esi].Nam3, [Esi].Value
		%DBG "%s", [Esi].Message
		%DBG " "
		add esi,sizeof(STID)
		dec ebx
	.until Zero?
	%DBG "\--------------------"
	ret
DbgListSTID endp