;  TLS.
;
; (c) Indy, 2012
;
; o   (RWL).
;
; Ip[]
TLS_PRE	equ 0
TLS_POST	equ 4
TLS_USER0	equ 2*4
TLS_USER4	equ 3*4

; Flags
TLS_BREAK			equ 00000001B
TLS_BREAK_BIT		equ 0
TLS_TRAP			equ 00000010B
TLS_TRAP_BIT		equ 1
TLS_VEH			equ 00000100B
TLS_VEH_BIT		equ 2
TLS_VEH_POST		equ 00001000B
TLS_VEH_POST_BIT	equ 3

TLS_ENTRY struct
Teb		PTEB ?
Tid		HANDLE ?	; TID
;Handle	HANDLE ?	;  .
Flags	DWORD ?
Gate		PVOID ?	;   .
Id		ULONG ?	; ID  .
User		PVOID 4 DUP (?)	;   UserClientDllInitialize().
Ip		PVOID API_NUMBER*4 DUP (?)
TLS_ENTRY ends
PTLS_ENTRY typedef ptr TLS_ENTRY

RDMUX	equ 0
WRMUX	equ 1

%BLOCK macro Mux, Bit
	.repeat
		lock bts Mux,Bit
	.until !Carry?
endm

%BUNLOCK macro Mux, Bit
	lock btr Mux, Bit
endm

RWLOCK struct
Mux		DWORD ?
Rc		ULONG ?
RWLOCK ends
PRWLOCK typedef ptr RWLOCK

TLS_MAX_ENTRIES	equ 200H

.data?
g_Tls			TLS_ENTRY TLS_MAX_ENTRIES DUP (<>)

ifndef OPT_ENABLE_RWL
	g_TlsLock			RWLOCK <>
else
	g_TlsLock			RTL_CRITICAL_SECTION <>
endif

.code
InitTls proc
	ret
InitTls endp

ifdef OPT_ENABLE_RWL

; BUGBUG:
;	1st	EvReadUnlock.BLOCKR
;	2st	EvWriteLock.BLOCKW
;
;
; Ecx: PRWLOCK
;
EvReadLock proc C
	assume ecx:PRWLOCK
	%BLOCK [Ecx].Mux, RDMUX
	inc [ecx].Rc	; mb XADD
	.if [Ecx].Rc == 1
		%BLOCK [Ecx].Mux, WRMUX
	.endif
	%BUNLOCK [Ecx].Mux, RDMUX
	ret
EvReadLock endp

EvReadUnlock proc C
	assume ecx:PRWLOCK
	%BLOCK [Ecx].Mux, RDMUX
	dec [ecx].Rc
	.if Zero?
		%BUNLOCK [Ecx].Mux, WRMUX
	.endif
	%BUNLOCK [Ecx].Mux, RDMUX
	ret
EvReadUnlock endp

EvWriteLock proc C
	%BLOCK RWLOCK.Mux[ecx], WRMUX
	ret
EvWriteLock endp

EvWriteUnlock proc C
	%BUNLOCK RWLOCK.Mux[ecx], WRMUX
	ret
EvWriteUnlock endp

%RLOCK macro pLock
	lea ecx,pLock
	Call EvReadLock
endm

%RUNLOCK macro pLock
	lea ecx,pLock
	Call EvReadUnlock
endm

%WLOCK macro pLock
	lea ecx,pLock
	Call EvWriteLock
endm

%WUNLOCK macro pLock
	lea ecx,pLock
	Call EvWriteUnlock
endm

%ISRLOCK macro Mux
	bt Mux, RDMUX
endm

%ISWLOCK macro Mux
	bt Mux, WRMUX
endm

else
%RLOCK macro pLock
	lea ecx,pLock
	%BLOCK RWLOCK.Mux[Ecx], RDMUX
endm

%RUNLOCK macro pLock
	lea ecx,pLock
	%BUNLOCK RWLOCK.Mux[Ecx], RDMUX
endm

%WLOCK macro pLock
	lea ecx,pLock
	%BLOCK RWLOCK.Mux[Ecx], RDMUX
endm

%WUNLOCK macro pLock
	lea ecx,pLock
	%BUNLOCK RWLOCK.Mux[Ecx], RDMUX
endm
endif

; +
;     .
;
	assume fs:nothing	
TlsCleaningCycle proc uses ebx esi edi
Local Free:PTLS_ENTRY, MmInfo:MEMORY_BASIC_INFORMATION
	%FENTER
	mov ebx,TLS_MAX_ENTRIES
	cld
	mov Free,NULL
	lea esi,g_Tls
	assume esi:PTLS_ENTRY
	.repeat
		cmp [esi].Teb,NULL
		.if Zero?
			mov eax,esi
			jmp Exit
		.endif
		invoke ZwQueryVirtualMemory, NtCurrentProcess, [Esi].Teb, MemoryBasicInformation, addr MmInfo, sizeof(MEMORY_BASIC_INFORMATION), NULL
		test eax,eax
		mov edi,esi
		jnz Clear
		cmp MmInfo.State,MEM_COMMIT
		jne Clear
		cmp MmInfo.Protect,PAGE_READWRITE
		mov eax,[esi].Teb
		jne Clear
		cmp MmInfo._Type,MEM_PRIVATE
		mov edx,[esi].Tid
		jne Clear
		.if (TEB.Tib.Self[Eax] != Eax) || (TEB.Cid.UniqueThread[Eax] != Edx)
	Clear:
			.if Free == NULL
				mov Free,edi
			.endif
			mov ecx,sizeof(TLS_ENTRY)/4
			xor eax,eax
			rep stosd
		.endif
		add esi,sizeof(TLS_ENTRY)
		dec ebx
	.until Zero?
Load:
	mov eax,Free
Exit:
	%FLEAVE
	ret
TlsCleaningCycle endp

; +
;  TLS    .
;
TlsAddEx proc uses ebx Teb:PTEB
	%WLOCK g_TlsLock
	mov edx,Teb
	assume edx:PTEB
	mov ecx,[edx].Cid.UniqueThread
	lea ebx,g_Tls
	assume ebx:PTLS_ENTRY
	mov eax,TLS_MAX_ENTRIES
	.repeat
	   cmp [ebx].Teb,NULL
	   je Alloc
	   cmp [ebx].Teb,edx
	   je IsTid
   Scan:
	   add ebx,sizeof(TLS_ENTRY)
	   dec eax
	.until Zero?
	;   .   .
	invoke TlsCleaningCycle	;   .
	jmp Exit
IsTid:
	cmp [ebx].Tid,ecx
	jne Scan
	jmp Load
;   ,  .
Alloc:
	mov [ebx].Teb,edx
	mov [ebx].Tid,ecx
Load:
	mov eax,ebx
Exit:
	%WUNLOCK g_TlsLock
	test eax,eax
	ret
TlsAddEx endp

; +
;
TlsAdd proc C
	invoke TlsAddEx, fs:[TEB.Tib.Self]
	ret
TlsAdd endp

; +
;  TLS  .
;
TlsGetEx proc uses ebx Teb:PTEB
	%RLOCK g_TlsLock
	mov edx,Teb
	assume edx:PTEB
	mov ecx,[edx].Cid.UniqueThread
	lea ebx,g_Tls
	assume ebx:PTLS_ENTRY
	mov eax,TLS_MAX_ENTRIES
	.repeat
	   cmp [ebx].Teb,NULL
	   je Error
	   cmp [ebx].Teb,edx
	   je IsTid
   Scan:
	   add ebx,sizeof(TLS_ENTRY)
	   dec eax
	.until Zero?
Error:
	xor eax,eax
Exit:
	%RUNLOCK g_TlsLock
	test eax,eax
	ret
IsTid:
	cmp [ebx].Tid,ecx
	jne Scan
Load:
	mov eax,ebx
	jmp Exit
TlsGetEx endp

; +
;
TlsGet proc C
	invoke TlsGetEx, fs:[TEB.Tib.Self]
	ret
TlsGet endp

; +
;   .
;
; o    ( ).
; o  (     
;   RWL   ).
;
	assume fs:nothing	
TlsEnumerate proc uses ebx esi edi Callback:PVOID, CallbackArg:PVOID
Local MmInfo:MEMORY_BASIC_INFORMATION
	%FENTER
	%WLOCK g_TlsLock
	mov ebx,TLS_MAX_ENTRIES
	cld
	lea esi,g_Tls
	assume esi:PTLS_ENTRY
	.repeat
		.if [Esi].Teb
			invoke ZwQueryVirtualMemory, NtCurrentProcess, [Esi].Teb, MemoryBasicInformation, addr MmInfo, sizeof(MEMORY_BASIC_INFORMATION), NULL
			test eax,eax
			mov edi,esi
			jnz Clear
			cmp MmInfo.State,MEM_COMMIT
			jne Clear
			cmp MmInfo.Protect,PAGE_READWRITE
			mov eax,[esi].Teb
			jne Clear
			cmp MmInfo._Type,MEM_PRIVATE
			mov edx,[esi].Tid
			jne Clear
			.if (TEB.Tib.Self[Eax] != Eax) || (TEB.Cid.UniqueThread[Eax] != Edx)
		Clear:
				mov ecx,sizeof(TLS_ENTRY)/4
				xor eax,eax
				rep stosd
			.else
				push CallbackArg
				push esi
				Call Callback
				test eax,eax
				jnz Exit
			.endif
		.endif
		add esi,sizeof(TLS_ENTRY)
		dec ebx
	.until Zero?
Exit:
	%WUNLOCK g_TlsLock
	%FLEAVE
	ret
TlsEnumerate endp