LDT_MASK		equ 100B

DESCRIPTOR_TABLE_ENTRY struct
Selector		ULONG ?
Descriptor	DWORD 2 DUP (?)	; LDT_ENTRY
DESCRIPTOR_TABLE_ENTRY ends
PDESCRIPTOR_TABLE_ENTRY typedef ptr DESCRIPTOR_TABLE_ENTRY

; +
;     .
;
; o Code segment!
;
; OUT:
;   Eax: base, Ecx: limit(last byte addr).
;
LogicToLinear proc ThreadHandle:HANDLE, Selector:ULONG, SegOffset:ULONG
Local T:DESCRIPTOR_TABLE_ENTRY
	mov eax,Selector
	xor ecx,ecx
	.if Eax == KGDT_R3_CODE or RPL_MASK	; Default, fast.
		mov eax,SegOffset
		dec ecx
		jmp Exit
	.endif
	lea edx,T
	mov T.Selector,eax
	push ecx
	push sizeof(DESCRIPTOR_TABLE_ENTRY)
	push edx
	push ThreadDescriptorTableEntry
	push ThreadHandle
	Call ZwQueryInformationThread
	test eax,eax
	mov ecx,D T.Descriptor[4]
	jnz Fail
	and ecx,1111100000000000B	; P, DPL, S, TYPE[1XXX]
	mov eax,D T.Descriptor[0]
	cmp ecx,1111100000000000B
	mov edx,D T.Descriptor[4]
	jne Fail
	shrd eax,edx,16
	shld eax,edx,8
	movzx ecx,W T.Descriptor[0]
	ror eax,8	; Base
	and edx,11110000000000000000B
	or ecx,edx	; Limit
	bt D T.Descriptor[4],23	; G
	.if !Carry?	; Bytes
		cmp SegOffset,ecx
		ja Fail	; Offset > Limit
	.else
		shl ecx,12
		or ecx,(X86_PAGE_SIZE - 1)
		cmp SegOffset,ecx
		ja Fail
	.endif
	add ecx,eax
	.if Carry?
Fail:
		xor eax,eax
		xor ecx,ecx
	.else
		add eax,SegOffset
	.endif
Exit:
	ret
LogicToLinear endp

; -  (     RWL  ).
; o  g_WaitThreadLock .
;
FLOW struct
Ip		PVOID ?
Linear	BOOLEAN ?
FLOW ends
PFLOW typedef ptr FLOW

LogicToLinear proto :HANDLE, :ULONG, :PVOID

; +
;     .
;
IsFlowCallback proc uses ebx Tls:PTLS_ENTRY, Flow:PFLOW
Local ObjAttr:OBJECT_ATTRIBUTES
Local ClientId:CLIENT_ID
Local ThreadHandle:HANDLE
Local Context:CONTEXT
	mov ecx,Tls
	xor eax,eax
	mov ecx,TLS_ENTRY.Tid[ecx]
	mov ObjAttr.uLength,sizeof(OBJECT_ATTRIBUTES)
	mov ObjAttr.hRootDirectory,eax
	mov ObjAttr.uAttributes,eax
	mov ObjAttr.pSecurityDescriptor,eax
	mov ObjAttr.pSecurityQualityOfService,eax
	mov ObjAttr.pObjectName,eax
	mov ClientId.UniqueProcess,eax
	mov ClientId.UniqueThread,ecx
	invoke ZwOpenThread, addr ThreadHandle, THREAD_GET_CONTEXT, addr ObjAttr, addr ClientId
	mov ecx,ClientId.UniqueThread
	.if (!Eax) && (fs:[TEB.Cid.UniqueThread] != Ecx)
		mov Context.ContextFlags,CONTEXT_CONTROL
		invoke ZwGetContextThread, ThreadHandle, addr Context
		mov ebx,Flow
		assume ebx:PFLOW
		.if !Eax
			cmp [ebx].Linear,FALSE
			mov eax,Context.rEip
			.if Zero?
				invoke LogicToLinear, ThreadHandle, Context.rCs, Eax
				.if !Eax
					inc eax
					jmp @f
				.endif
			.endif
			.if [Ebx].Ip == Eax
				mov eax,TRUE
			.else
				xor eax,eax
			.endif
		.endif
	@@:
		push eax
		invoke ZwClose, ThreadHandle
		pop eax
	.endif
	ret
IsFlowCallback endp

; +
;       .
;
IsFlowPointer proc Ip:PVOID, Linear:BOOLEAN
Local Info:BOOLEAN
	invoke ZwQueryInformationThread, NtCurrentThread, ThreadAmILastThread, addr Info, sizeof(BOOLEAN), NULL
	.if Eax || (!Info)
		xor eax,eax
	.else
		invoke TlsEnumerate, addr IsFlowCallback, addr Ip
	.endif
	ret
IsFlowPointer endp

; +
; 
LockCallback proc Tls:PTLS_ENTRY, Resume:BOOLEAN
Local ObjAttr:OBJECT_ATTRIBUTES
Local ClientId:CLIENT_ID
Local ThreadHandle:HANDLE
	mov ecx,Tls
	xor eax,eax
	mov ecx,TLS_ENTRY.Tid[ecx]
	mov ObjAttr.uLength,sizeof(OBJECT_ATTRIBUTES)
	mov ObjAttr.hRootDirectory,eax
	mov ObjAttr.uAttributes,eax
	mov ObjAttr.pSecurityDescriptor,eax
	mov ObjAttr.pSecurityQualityOfService,eax
	mov ObjAttr.pObjectName,eax
	mov ClientId.UniqueProcess,eax
	mov ClientId.UniqueThread,ecx
	invoke ZwOpenThread, addr ThreadHandle, THREAD_SUSPEND_RESUME, addr ObjAttr, addr ClientId
	mov ecx,ClientId.UniqueThread
	.if (!Eax) && (fs:[TEB.Cid.UniqueThread] != Ecx)
		push eax
		push ThreadHandle
		.if !Resume
			Call ZwSuspendThread
		.else
			Call ZwResumeThread
		.endif
	.endif
	invoke ZwClose, ThreadHandle
	xor eax,eax
	ret
LockCallback endp

; +
;  .
;
LockThreads proc
	mov g_WaitThreadLock,TRUE
	invoke TlsEnumerate, addr LockCallback, FALSE
	ret
LockThreads endp

; +
;  .
;
UnlockThreads proc
	invoke TlsEnumerate, addr LockCallback, TRUE
	mov g_WaitThreadLock,FALSE
	ret
UnlockThreads endp